Graphics3D 800,600,32,1

SetBuffer BackBuffer()

cam = CreateCamera()
CameraZoom cam,1
CameraRange cam,1,10000
CameraClsColor cam,128,128,128

movespeed#=0.5

pivot=CreatePivot()

; Starsphere erstellen
starsphere=InitStarSphere(cam,10000,0.1,0.25,0.97,255,255,10,1)
EntityBlend starsphere,3
EntityParent starsphere,pivot
sterntex=LoadTexture("stern.png",2)
EntityTexture starsphere,sterntex

; Fogsphere erstellen
fogsphere=LoadMesh("geo6.3ds")
ScaleEntity fogsphere,10,10,10
fogtex=LoadTexture("nebel.jpg")
EntityTexture fogsphere,fogtex
EntityAlpha fogsphere,0.5
FlipMesh fogsphere
EntityFX fogsphere,1
EntityOrder fogsphere,1
EntityBlend fogsphere,3
EntityParent fogsphere,pivot

; Starbox erstellen
starbox=CreateCube()
ScaleEntity starbox,10,10,10
EntityFX starbox,1
EntityOrder starbox,2
startex=LoadTexture("sterne.png")
EntityTexture starbox,startex
FlipMesh starbox
EntityParent starbox,pivot

MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

; Main loop
While Not KeyHit(1)
	
	; FPS
    FPS_C=FPS_C+1 
    If ms<MilliSecs() 
        ms=MilliSecs()+1000
        FPS=FPS_C 
        FPS_C=0 
    EndIf
	
	; Drehung, um Seams zu entlarven
	If dr=0 Then TurnEntity pivot,0,0.01,0
	
	; Frame tweening
    Tween#=Float(MilliSecs()-FrameTime)/Float(20.0) : FrameTime=MilliSecs()
	
	; Bewegung
    mxs#=MouseXSpeed()
	mys#=MouseYSpeed()
	RotateEntity cam,EntityPitch(cam)+(mys#/5),EntityYaw(cam)-(mxs#/5),0
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	If KeyDown(200) Then MoveEntity cam,0,0,movespeed*tween
	If KeyDown(208) Then MoveEntity cam,0,0,-movespeed*tween
	If KeyDown(205) Then MoveEntity cam,movespeed*tween,0,0
	If KeyDown(203) Then MoveEntity cam,-movespeed*tween,0,0
	
	; SPACE: Fogsphere zeigen/verstecken
	If KeyHit(57) Then fs=1-fs : If fs=1 Then HideEntity fogsphere Else ShowEntity fogsphere
	
	; W: Wireframe an/aus
	If KeyHit(17) Then wf=1-wf : WireFrame wf
	
	; D: Drehung an/aus
	If KeyHit(32) Then dr=1-dr
	
	RenderWorld
	
    Text 0,0,FPS
	Text 0,15,TrisRendered()
    
	Flip 0
    
Wend

End

Function InitStarSphere(cam%,stars%,min#,max#,fix#,mincol%,maxcol%,range#,scale#=1.0)
	
	Local star%,mesh%,surf%
	Local i%,size#,h%,a#
	Local cx#,cy#,cz#
	Local r%,g%,b%
	
	; einzelnes Sternenquad erstellen
	star=CreateQuad()
	
	; Starsphere erstellen
	mesh = CreateMesh()
	surf = CreateSurface(mesh)
	EntityFX mesh,1+2+16
	
	cx=EntityX(cam)
	cy=EntityX(cam)
	cz=EntityX(cam)
	
	; alle Sterne erstellen
	For i=1 To stars
		
		; Neue Surface erstellen wenn zuviele Vertices vorhanden
		If CountVertices(surf)>32767 Then surf=CreateSurface(mesh)
		
		; Sterngrsse
		size=min*scale;Rnd(min*scale,max*scale)
		If Rnd(1)>fix Then size=Rnd(min,max)*scale
		ScaleEntity star,size,size,size
		
		; Starquad zurck auf Kameraposition
		PositionEntity star,cx,cy,cz
		
		; Starquad zufllig drehen, von der Mitte wegbewegen und auf die Kamera zeigen
		TurnEntity star,Rnd(0,Rnd(180,360)),Rnd(0,Rnd(180,360)),Rnd(0,Rnd(180,360))
		MoveEntity star,0,0,range*scale
		PointEntity star,cam
		
		; Farbe
		col#=Rnd(1)
		If col>0.75 And col<=1.00 Then r=255 : g=224 : b=192
		If col>0.50 And col<=0.75 Then r=255 : g=255 : b=192
		If col>0.25 And col<=0.50 Then r=192 : g=224 : b=255
		If col>0.00 And col<=0.25 Then
			h=Rand(mincol,maxcol)
			r=h
			g=h
			b=h
		EndIf
		
		; Alpha
		If size>min*scale Then a#=1.0 Else a#=Rnd(0.1,1)
		
		; Starquad zur Starsphere hinzufgen
		AddToSurface(star,surf,mesh,r,g,b,a)
		
	Next
	
	; Quad lschen
	FreeEntity star
	
	Return mesh
	
End Function

; Mesh mit allen Eigenschaften einer Surface hinzufgen
Function AddToSurface(mesh, surf,singlesurfaceentity,r%,g%,b%,a#) 
	
	Local vert%[2],vr%[2],vg%[2],vb%[2],va#[2]
	Local surface%,oldvert%,i%,i2%,s%
	
	surface = GetSurface(mesh,1) 
	For i = 0 To CountTriangles(surface)-1 
		For i2 = 0 To 2 
			oldvert = TriangleVertex(surface,i,i2)
			vr[i2]=r
			vg[i2]=g
			vb[i2]=b
			va[i2]=a
			
			TFormPoint VertexX(surface,oldvert),VertexY(surface,oldvert),VertexZ(surface,oldvert), mesh,singlesurfaceentity 
			vert[i2] = AddVertex(surf,TFormedX(),TFormedY(),TFormedZ(),VertexU(surface,oldvert),VertexV(surface,oldvert)) 
			VertexColor surf,vert[i2],r,g,b,a
		Next 
		
		AddTriangle(surf,vert[0],vert[1],vert[2])
		
	Next 
	
End Function

; Quad erstellen
Function CreateQuad(r%=255,g%=255,b%=255,a#=1.0,fx%=0)
	
	Local mesh%,surf%,v1%,v2%,v3%,v4%
	
	mesh=CreateMesh()
	surf=CreateSurface(mesh)
	
	v1=AddVertex(surf,-1,1,0,1,0)
	v2=AddVertex(surf,1,1,0,0,0)
	v3=AddVertex(surf,-1,-1,0,1,1)
	v4=AddVertex(surf,1,-1,0,0,1)
	
	VertexColor surf,v1,r,g,b,a
	VertexColor surf,v3,r,g,b,a
	VertexColor surf,v2,r,g,b,a
	VertexColor surf,v4,r,g,b,a
	
	AddTriangle(surf,0,1,2)
	AddTriangle(surf,3,2,1)
	
	EntityFX mesh,fx
	
	Return mesh
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D